//-----------------------------------------------------------------------------
// abon.h
// Interface to adaboost evaluator plugin
// Jiri Havel, DCGM FIT BUT, Brno
// $Id: abon.h 41 2009-03-30 14:17:43Z ihavel $
//-----------------------------------------------------------------------------
#ifndef _ABON_H_
#define _ABON_H_

#include <aboninterface.h>

#ifdef __cplusplus
extern "C" {
#endif

/*
//typedef double abonTimerFunction();

void abonSetOpenGLUse(int flag); // 1 - smi se pouzit, 0 - nech ho byt
void abonSetMaxDetectionsPerFrame(int max);
//void abonSetTimer(abonTimerFunction *fn);
void abonSetXYZ();
// ...
*/

//zabalen voln do rozumnjho tvaru

static inline abonErrorCode abonSetVerbosity(abonDetector *detector, unsigned verbosity)
{
	return detector->setVerbosity(detector, verbosity);
}
static inline abonErrorCode abonSetTimer(abonDetector *detector, Timer *timer)
{
	return detector->setTimer(detector, timer);
}
static inline abonErrorCode abonSetClassifier(abonDetector *detector, TClassifier *classifier)
{
	return detector->setClassifier(detector, classifier);
}
static inline abonErrorCode abonSetStep(abonDetector *detector, unsigned hstep, unsigned vstep)
{
	return detector->setStep(detector, hstep, vstep);
}
static inline abonErrorCode abonSetSize(abonDetector *detector, unsigned width, unsigned height, unsigned pitch)
{
	return detector->setSize(detector, width, height, pitch);
}
static inline abonErrorCode abonProcess(abonDetector *detector, abonImageData *image)
{
	return detector->process(detector, image);
}
static inline abonErrorCode abonStart(abonDetector *detector, abonCbGetImage *get, abonCbPutImage *put, void *param)
{
	return detector->start(detector, get, put, param);
}

//funkce pro nacteni pluginu

/// Load plugin dll/so and init detector
abonDetector *abonLoad(const char *engine);
/// Kill detector and release dll/so
void abonUnload(abonDetector *detector);

//ostatn funkce

/// Translate abonErrorCode to human readable form
const char *abonTranslateError(abonErrorCode error);
/// Translate abonTimeStamp to human readable form
const char *abonTranslateTimeStamp(abonTimeStamps timestamp);

#ifdef __cplusplus
}
#endif

#ifdef __cplusplus
/// C++ wrapper for abonDetector
/// currently only unloads
class DetectorPtr
{
private :
	abonDetector *detector;
public :
	DetectorPtr(abonDetector *d) : detector(d) {}
	~DetectorPtr() { abonUnload(detector); }
};
#endif

#endif
