/*
 * classifier.cpp
 * $Id: classifier.cpp 72 2009-04-08 15:49:58Z ihavel $
 */

#include <classifier.h>
//#include <simplexml.h>

#include <sstream>
#include <iostream>
#include <map>
#include <vector>

using namespace std;

int initClassifier(TClassifier * classifier)
{
    float * stgAlpha = classifier->alpha;

    for (unsigned s = 0; s < classifier->stageCount; ++s, stgAlpha += classifier->alphaCount)
    {
        TStage & stage = classifier->stage[s];
        
        if (stage.w > 2 || stage.h > 2) // No blocks larger than 2x2 allowed
            return 0;

        // Additional parameter checks?

        // get feature type
        // 000000wh
        stage.szType = ((stage.h-1) << 1) | (stage.w-1);
        // get position type
        // 0000yyxx
        stage.posType = ((stage.y & 0x03) << 2) | (stage.x & 0x03);
        // Link alpha table
        stage.alpha = stgAlpha + 8; // offset the pointer to avoid sum later in feature evaluation
    }

    return 1;
}


void releaseClassifier(TClassifier ** classifier)
{
    if (classifier && *classifier)
    {
        TClassifier & c = **classifier;
        if (c.alpha) delete [] c.alpha;
        if (c.stage) delete [] c.stage;
        delete *classifier;
        *classifier = 0;
    }
}


/*static void loadLRDFeature(xmlNodePtr fNode, TStage * stage)
{
    if (!fNode) return;
    getAttr(stage->x, "positionX", fNode);
    getAttr(stage->y, "positionY", fNode);
    getAttr(stage->w, "blockWidth", fNode);
    getAttr(stage->h, "blockHeight", fNode);
    int A,B;
    getAttr(A, "blockA", fNode);
    getAttr(B, "blockB", fNode);
    stage->A = A;
    stage->B = B;
}*/


/*static void loadHistogramWeakHypothesis(xmlNodePtr hNode, TStage * stage, vector<float> & predictTable)
{
    if (!hNode) return;
            
    istringstream predictStr(getAttr("predictionValues", hNode));

    float p;
    while (predictStr >> p)
    {
        predictTable.push_back(p);
    }

    loadLRDFeature(getNode("LRDFeature", hNode), stage);
}*/


/*static void loadDTWeakHypothesis(xmlNodePtr hNode, TStage * stage, vector<float> & predictTable)
{
    if (!hNode) return;
            
    istringstream predictStr(getAttr("predictionValues", hNode));
    istringstream binMapStr(getAttr("binMap", hNode));

    vector<float> predict;
    float p;
    while (predictStr >> p)
    {
        predict.push_back(p);
    }

    int bin;
    while (binMapStr >> bin)
    {
        predictTable.push_back(predict[bin]);
    }

    loadLRDFeature(getNode("LRDFeature", hNode), stage);
}*/

TClassifier * loadClassifierXML(const char * filename)
{
	return 0; // fuck with libxml2

    /*xmlDocPtr inputXML = xmlParseFile(filename);
    TClassifier * classifier = 0;
    xmlNodePtr classifierRoot;

    if (!inputXML)
    {
        cerr << "Cannot parse file" << endl;
        return 0;
    }

    //classifierRoot = getNode("WaldBoostClassifier", xmlDocGetRootElement(inputXML));
    classifierRoot = xmlDocGetRootElement(inputXML);

    if (!classifierRoot)
    {
        cerr << "Cannot find classifier root" << endl;
        return 0;
    }
    
    classifier = new TClassifier();

    getAttr(classifier->width, "sizeX", classifierRoot);
    getAttr(classifier->height, "sizeY", classifierRoot);
    classifier->threshold = 0.0f;

    //cout << "[w=" << classifier->width << "; h=" << classifier->height << "]" << endl;

    vector<TStage> tmpStages;
    vector< vector<float> > tmpPredict;
    
    for (xmlNodePtr node = classifierRoot->children; node; node = node->next)
    {
        if (xmlStrcmp(node->name, BAD_CAST "stage") == 0)
        {
            // load stage
            TStage stage = {0,0,1,1,0,1,0.0f};
            //cout << "stage:[";
            
            double theta;
            getAttr(theta, "negT", node);
            if (theta > 5000.0) theta = 5000.0;
            if (theta < -5000.0) theta = -5000.0;
            stage.theta_b = float(theta);
            //cout << "theta=" << stage.theta_b << "; ";

            // load hypothesis part
            xmlNodePtr hypothesisNode = 0;
            if (!hypothesisNode)
            {
                hypothesisNode = getNode("HistogramWeakHypothesis", node);
                if (hypothesisNode)
                {
                    tmpPredict.push_back(vector<float>());
                    loadHistogramWeakHypothesis(hypothesisNode, &stage, tmpPredict.back());
                }
                else 
                {
                    hypothesisNode = getNode("DecisionTreeWeakHypothesis", node);
                    if (hypothesisNode)
                    {
                        tmpPredict.push_back(vector<float>());
                        loadDTWeakHypothesis(hypothesisNode, &stage, tmpPredict.back());
                    }
                }
                
            }
            
            if (!hypothesisNode)
            {
                cerr << "Warning: Incomplete stage encountered" << endl;
            }
            
            //cout << "x=" << stage.x << "; ";
            //cout << "y=" << stage.y << "; ";
            //cout << "w=" << stage.w << "; ";
            //cout << "h=" << stage.h << "; ";
            //cout << "A=" << int(stage.A) << "; ";
            //cout << "B=" << int(stage.B) << "]";
            //vector<float> & predict = tmpPredict.back();
            //cout << "[s=" << predict.size()<<"; ";
            //for (int i = 0; i < predict.size(); ++i)
            //{
            //    cout << predict[i] << ",";
            //}
            //cout << "]" << endl;
            tmpStages.push_back(stage);            
        }
    }

    // Alloc the stages and alphas, and copy loaded data
    
    classifier->stageCount = tmpStages.size();
    classifier->alphaCount = 17;
   
    classifier->stage = new TStage[tmpStages.size()];
    classifier->alpha = new float[tmpStages.size() * 17];
    for (unsigned s = 0; s < tmpStages.size(); ++s)
    {
        classifier->stage[s] = tmpStages[s];
        if (tmpPredict[s].size() != 17)
            cerr << "Warning: Incorrect stage (" << s << ")" << endl;
        float * dstAlpha = classifier->alpha + 17 * s;
        copy(tmpPredict[s].begin(), tmpPredict[s].end(), dstAlpha);        
    }

    return classifier;*/
}

void exportClassifierHeader(TClassifier * c, ostream & str, const char * name)
{
    str << "#ifndef _"<< name << "_\n#define _" << name << "_\n\n";

    str << "#include <classifier.h>\n\n";

    str << "#define STAGE_COUNT " << c->stageCount << "\n";
    str << "#define ALPHA_COUNT " << c->alphaCount << "\n\n";

    str << "TStage _stages_" << name << "[STAGE_COUNT] = {\n";
    for (unsigned s = 0; s < c->stageCount; ++s)
    {
        TStage & stg = c->stage[s];
        str << "{ " <<
            stg.x << ", " << stg.y << ", " <<
            stg.w << ", " << stg.h << ", " <<
            int(stg.A) << ", " << int(stg.B) << ", " <<
			showpoint << stg.theta_b << "f, " <<
            0 << ", " << // alpha
            0 << ", " << 0 << "},\n"; // szType, posType
    }
    str << "};\n\n";

    str << "float _alphas_" << name << "[STAGE_COUNT * ALPHA_COUNT] = {\n";
    float * alpha = c->alpha;
    for (unsigned s = 0; s < c->stageCount; ++s, alpha+=c->alphaCount)
    {
        for (unsigned a = 0; a < c->alphaCount; ++a)
        {
            str << alpha[a] << "f, ";
        }
        str << "\n";
    }
    str << "};\n\n";
    
    str << "TClassifier " << name << " = {\n";
    str << "STAGE_COUNT, STAGE_COUNT, ALPHA_COUNT, " << 
        c->threshold << ", " << 
        c->width << ", " << c->height << ", " <<
        "(TStage*) _stages_" << name << ", (float*) _alphas_" << name << ", \n";
    str << "};\n\n";
    
    str << "#endif\n" << endl;
}
