//-----------------------------------------------------------------------------
// config.cpp
// Detector configuration
// Jiri Havel, DCGM FIT BUT, Brno
// $Id: config.cpp 58 2009-04-02 09:06:59Z ijuranek $
//-----------------------------------------------------------------------------
#include "config.h"

#include <assert.h>
#include <iterator>

namespace std {

ostream & operator<<(ostream & o, const Config::Input & i)
{
	switch(i.type)
	{
	case Config::Input::CAMERA :
		o << "camera " << i.number;
		break;
	case Config::Input::VIDEO :
		o << "video '" << i.name << "'";
		break;
	case Config::Input::IMAGE :
		o << "image '" << i.name << "'";
		break;
	case Config::Input::DATASET :
		o << "dataset";
		break;
	case Config::Input::SEQUENCE :
		o << "sequence " << i.number;
		break;
	default :
		assert(!"Invalid input type!");
	}
	return o;
}

ostream & operator<<(ostream & o, const Config & c)
{
	o	<< "engine '" << c.engine << "'\n"
		<< (c.noearly ? "adaboost" : "waldboost") << " classifier '" << c.classifier << "', threshold " << c.threshold << ", " << c.stages << " stages\n"
		<< "group threshold " << c.groupThreshold << " min " << c.groupMinCount << endl
		<< "preprocess smooth " << c.smooth << " base " << c.scaleBase << endl
		<< "output to '" << c.output << "' fourcc " << c.fourcc << " "
		<< (c.tag ? "tag, " : "") << (c.show ? "show, " : "") << (c.drawAll ? "draw all detections" : "") << endl
		<< "db " << c.database << " dataset " << c.dataset << " in " << c.datapath << ", process " << c.process << endl
		<< (c.verbose ? "verbose output\n" : "")
		<< "video start " << c.start << " frames " << c.frames << " step " << c.step << endl
		<< "Input :\n";
    ostream_iterator<Config::Input> outIterator(o, "\n");
	copy(c.inputs.begin(), c.inputs.end(), outIterator);
	return o;
}

}
