//-----------------------------------------------------------------------------
// config.h
// Detector configuration
// Jiri Havel, DCGM FIT BUT, Brno
// $Id: config.h 41 2009-03-30 14:17:43Z ihavel $
//-----------------------------------------------------------------------------
#ifndef _DETECT_CONFIG_H_
#define _DETECT_CONFIG_H_

#include <string>
#include <ostream>
#include <vector>

struct Config
{
	std::string engine;

	std::string classifier;
	double threshold;
	unsigned stages;
	bool noearly;
	unsigned hstep, vstep;

	double groupThreshold;
	unsigned groupMinCount;

	unsigned smooth;
	double scaleBase;

	std::string output;
	std::string detections;
	std::string timestamps;
	unsigned fourcc;
	bool tag;
	bool show;
	bool drawAll;

	std::string database;
	std::string datapath;
	std::string dataset;
	std::string process;
	std::string description;

	bool verbose;

	unsigned start, frames, step;
	struct Input
	{
		enum Type
		{
			IMAGE,
			VIDEO,
			CAMERA,
			DATASET,
			SEQUENCE
		} type;
		int number;
		std::string name;
		Input(const Type t) : type(t) {}
		Input(const Type t, const int c) : type(t), number(c) {}
		Input(const Type t, const std::string & n) : type(t), name(n) {}
	};
	typedef std::vector<Input> Inputs;
	Inputs inputs;
};

namespace std {

std::ostream & operator<<(std::ostream & o, const Config::Input & i);
std::ostream & operator<<(std::ostream & o, const Config & c);

}

#endif
