//-----------------------------------------------------------------------------
// io.h
// Input/output wrapper
// Jiri Havel, DCGM FIT BUT, Brno
// $Id: io.h 72 2009-04-08 15:49:58Z ihavel $
//-----------------------------------------------------------------------------
#ifndef _DETECT_INPUT_OUTPUT_H_
#define _DETECT_INPUT_OUTPUT_H_

#include "input.h"

class InputOutput
{
private :
	const Config &config;
	abonDetector *detector;

	Timer *timer;
	double times[abontsNumTimeStamps];

	bool quit;
	Input *input;
	Output *output;

	unsigned frames;
	Image *image;

	unsigned faces;

	ImageManager manager;

	static abonImageData *ioGetImage(void *param);
	static abonErrorCode ioPutImage(void *param, abonImageData *image);
public :
	InputOutput(const Config &cfg, abonDetector *det, Timer *timer);
	~InputOutput() throw();

	bool runWithIO(Input *in, Output *out);
};



#endif
